unit Unit10;
{
  Copyright (C) 2013-2015 Marc SERRAU

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}
{$mode delphi}

interface
{$IFDEF MSWINDOWS}
uses
  Windows,SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls, Buttons, FileUtil;
{$ELSE}
uses
    LCLtype, SysUtils, Variants, Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls, Grids, ExtCtrls, Buttons, FileUtil;
{$ENDIF}
type

  { TForm10 }

  TForm10 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ButtonMAJCodeUAI: TButton;
    CheckBoxForceGEOS: TCheckBox;
    CheckBoxKeepGEOSData: TCheckBox;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit10: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit8: TLabeledEdit;
    LabeledEdit9: TLabeledEdit;
    LabeledEditRapportAFOEV: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    RadioButtonLangue1: TRadioButton;
    RadioButtonLangue2: TRadioButton;
    RadioGroup1: TRadioGroup;
    SelectDirectoryDialog1: TSelectDirectoryDialog;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ButtonMAJCodeUAIClick(Sender: TObject);
    procedure CheckBoxForceGEOSClick(Sender: TObject);
    procedure CheckBoxKeepGEOSDataChange(Sender: TObject);
    procedure CheckBoxKeepGEOSDataClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LabeledEdit10Change(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure LabeledEdit4Change(Sender: TObject);
    procedure LabeledEdit5Change(Sender: TObject);
    procedure LabeledEdit8Change(Sender: TObject);
    procedure LabeledEdit9Change(Sender: TObject);
    procedure LabeledEditRapportAFOEVChange(Sender: TObject);
    procedure RadioButtonLangue1Change(Sender: TObject);
    procedure RadioButtonLangue1Click(Sender: TObject);
    procedure RadioButtonLangue2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form10: TForm10;

  LFic_GCVS,LRep_AAVSO,LURL_sn,LURL_GCVS    : PChar;

implementation

{$R *.lfm}

{ TForm10 }
uses
   Unit1;

procedure TForm10.BitBtn1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
     LabeledEdit1.Text:=OpenDialog1.FileName;
//     Fic_GCVS:=String(UTF8ToSys(OpenDialog1.FileName));
     Fic_GCVS:=OpenDialog1.FileName;
  end;
end;

procedure TForm10.BitBtn3Click(Sender: TObject);
begin
  if langage='FR' then
     SelectDirectoryDialog1.Title:='Répertoire des images AAVSO'
  else
     SelectDirectoryDialog1.Title:='AAVSO images Directory';

  If SelectDirectoryDialog1.Execute then
  begin
//     Rep_AAVSO:=String(UTF8ToSys(SelectDirectoryDialog1.FileName));
     Rep_AAVSO:=SelectDirectoryDialog1.FileName;
     LabeledEdit9.Text:=Rep_AAVSO;
  end;
end;

procedure TForm10.BitBtn4Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
   begin
      LabeledEditRapportAFOEV.Text:=OpenDialog1.FileName;
//      Fic_RapportAFOEV:=String(UTF8ToSys(OpenDialog1.FileName));
      Fic_RapportAFOEV:=OpenDialog1.FileName;
   end;
end;

procedure TForm10.Button1Click(Sender: TObject);
begin
   Form1.Sauverconfig
end;

procedure TForm10.Button2Click(Sender: TObject);
begin
   Button2.Enabled:=False;
   if Form1.DownloadFileHttp(LabeledEdit5.Text,LabeledEdit1.Text) then
      if langage='FR' then Application.MessageBox('Fichier GCVS récupéré et enregistré','',MB_OK)
      else Application.MessageBox('GCVS file downloaded and stored','',MB_OK)
   else
      if langage='FR' then Application.MessageBox('Impossible de récupérer le fichier GCVS. URL ?','',MB_OK)
      else Application.MessageBox('Unable to download GCVS file. URL ?','',MB_OK);
   Button2.Enabled:=True
end;

procedure TForm10.Button3Click(Sender: TObject);

begin

   if langage='FR' then
      SelectDirectoryDialog1.Title:='Répertoire de stockage des requêtes d''Observation AFOEV'
   else
      SelectDirectoryDialog1.Title:='AFOEV Request For Observation storing directory';

   If SelectDirectoryDialog1.Execute then
   begin
//      Rep_ReqAFOEV:=String(UTF8ToSys(SelectDirectoryDialog1.FileName));
      Rep_ReqAFOEV:=SelectDirectoryDialog1.FileName;
      LabeledEdit9.Text:=Rep_ReqAFOEV;
   end;
end;

procedure TForm10.Button4Click(Sender: TObject);
begin
   if langage='FR' then
      SelectDirectoryDialog1.Title:='Répertoire de stockage des requêtes d''observation AAVSO'
   else
      SelectDirectoryDialog1.Title:='AAVSO Request For Observation storing directory';

   If SelectDirectoryDialog1.Execute then
   begin
//      Rep_ReqAAVSO:=String(UTF8ToSys(SelectDirectoryDialog1.FileName));
      Rep_ReqAAVSO:=SelectDirectoryDialog1.FileName;
      LabeledEdit10.Text:=Rep_ReqAAVSO;
   end;
end;

procedure TForm10.ButtonMAJCodeUAIClick(Sender: TObject);
var
  FichierObsCodes,FichierObsCodesLocal : string;
begin
   ButtonMAJCodeUAI.Enabled:=False;
   FichierObsCodes:='http://www.minorplanetcenter.net/iau/lists/ObsCodes.html';
   FichierObsCodesLocal:='./ObsCodes.txt';
   if Form1.DownloadFileHttp(FichierObsCodes,FichierObsCodesLocal) then
      if langage='FR' then Application.MessageBox('Fichier ObsCodes récupéré du MPC et enregistré.','',MB_OK)
      else Application.MessageBox('ObsCodes file downloaded from MPC and stored.','',MB_OK)
   else
      if langage='FR' then Application.MessageBox('Impossible de récupérer le fichier ObsCodes du MPC. Mauvais URL ???','',MB_OK)
      else Application.MessageBox('Unable to download ObsCodes file from MPC. Bad URL ???','',MB_OK);
   ButtonMAJCodeUAI.Enabled:=True
end;

procedure TForm10.CheckBoxForceGEOSClick(Sender: TObject);
begin
   ForceGEOS:=CheckBoxForceGEOS.Checked;
end;

procedure TForm10.CheckBoxKeepGEOSDataChange(Sender: TObject);
begin

end;

procedure TForm10.CheckBoxKeepGEOSDataClick(Sender: TObject);
begin
  KeepGEOS:=CheckBoxKeepGEOSData.Checked;
end;

procedure TForm10.FormCreate(Sender: TObject);
begin

end;

procedure TForm10.FormHide(Sender: TObject);
begin
//   Application.MessageBox(mesg[15],'',MB_OK);
end;

procedure TForm10.FormShow(Sender: TObject);
begin
   LFic_GCVS:=PChar(Fic_GCVS);
   LRep_AAVSO:=PChar(Rep_AAVSO);
   LURL_sn:=PChar(URL_sn);
   LURL_GCVS:=PChar(URL_GCVS);

   Form10.LabeledEdit1.Text:=Fic_GCVS;
   Form10.LabeledEdit3.Text:=Rep_AAVSO;
   Form10.LabeledEdit4.Text:=URL_sn;
   Form10.LabeledEdit5.Text:=URL_GCVS;

   if langage='FR' then RadiobuttonLangue1.Checked:=True;
   if langage='EN' then RadiobuttonLangue2.Checked:=True;
   Form10.LabeledEdit9.Text:=Rep_ReqAFOEV;
   LabeledEdit10.Text:=Rep_ReqAAVSO;
   LabeledEditRapportAFOEV.Text:=Fic_RapportAFOEV;
   LabeledEdit8.Text:=URL_Novae;

   CheckBoxForceGEOS.checked:=ForceGEOS;
   CheckBoxKeepGEOSData.checked:=KeepGEOS;


   if langage='EN' then
   begin
      Form10.LabeledEdit1.EditLabel.Caption:='GCVS Base Location :';
      Form10.LabeledEdit5.EditLabel.Caption:='URL of GCVS file :';
      Form10.Button2.Caption:='Download';
      Form10.LabeledEdit3.EditLabel.Caption:='Directory for AAVSO charts :';
      Form10.LabeledEdit4.EditLabel.Caption:='URL of file for recent supernovae';
      Form10.LabeledEdit8.EditLabel.Caption:='URL of file for recent extragalactic novae';
      Form10.Button1.Caption:='Save configuration';
      Form10.RadioGroup1.Caption:='Language';
      CheckBoxForceGEOS.Caption:='At Start, update GCVS with previously saved AFOEV and GEOS data';
      CheckBoxKeepGEOSData.Caption:='At Stop, rewrite AFOEV and GEOS data';
      Form10.LabeledEditRapportAFOEV.EditLabel.Caption:='AFOEV Report of Measures file :';
   end;
end;

procedure TForm10.LabeledEdit10Change(Sender: TObject);
begin
   Rep_ReqAAVSO:=LabeledEdit10.Text;
end;

procedure TForm10.LabeledEdit1Change(Sender: TObject);
begin
   Fic_GCVS:=LabeledEdit1.Text;
end;

procedure TForm10.LabeledEdit4Change(Sender: TObject);
begin
   Rep_AAVSO:=LabeledEdit3.Text;
end;

procedure TForm10.LabeledEdit5Change(Sender: TObject);
begin
   URL_GCVS:=LabeledEdit5.Text
end;

procedure TForm10.LabeledEdit8Change(Sender: TObject);
begin
   URL_Novae:=LabeledEdit8.Text;
end;

procedure TForm10.LabeledEdit9Change(Sender: TObject);
begin
   Rep_ReqAFOEV:=LabeledEdit9.Text;
end;

procedure TForm10.LabeledEditRapportAFOEVChange(Sender: TObject);
begin
   URL_sn:=LabeledEdit4.Text;
end;

procedure TForm10.RadioButtonLangue1Change(Sender: TObject);
begin

end;

procedure TForm10.RadioButtonLangue1Click(Sender: TObject);
begin
    Langage:='FR';
end;

procedure TForm10.RadioButtonLangue2Click(Sender: TObject);
begin
    Langage:='EN';
end;

end.

